#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <malloc.h>
#include <stdlib.h>
#include <glib.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/videodev.h>
#include <sys/soundcard.h>
#include <math.h>
#include "channels.h"
#include <pthread.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <SDL/SDL.h>       
#include "cells_sh.h"

#define CHUNK 1024

struct fgdevice fg;

int mididstr (struct _Channel *ch);
int midird (struct _Channel *ch, unsigned char *buf, unsigned int len);
int webwr (struct _Channel *ch, unsigned char *buf, unsigned int len);
int webdstr (struct _Channel *ch);
int loopdstr(struct _Channel *ch);
int looprd(struct _Channel *ch, unsigned char *buf, unsigned int len);
int shareddstr (struct _Channel *ch);
int sharedrd (struct _Channel *ch, unsigned char *buf, unsigned int len);
int sharedwr (struct _Channel *ch, unsigned char *buf, unsigned int len);


struct LoopChannel
{
  int rdcounter;
  int fd;
};

struct WebChannel
{
  int rdcounter;
  unsigned char wrbuf[BUFFERSIZE];
};

struct SharedChannel
{
  int rdcounter;
  int wrcounter;
  unsigned char* sharedbuffer1;
  unsigned char* sharedbuffer2;
  int shmid3;
  int shmid4;
};
   

int
filewr (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  unsigned int x=0,cnt=0;

  struct FileChannel * fc = ch->data;

  write(fc->fd,buf,len);

  /*  while (len>0){
    if (len>(BUFFERSIZE-fc->intwrcounter)) cnt=BUFFERSIZE-fc->intwrcounter;
    else cnt=len;
    for (x=0;x<cnt;x++){
      fc->wrbuf[fc->intwrcounter+x]=buf[x+fc->extwrcounter];
    }
    len=len-cnt;
    fc->intwrcounter+=cnt;
    fc->extwrcounter+=cnt;
    fc->intwrcounter=fc->intwrcounter%BUFFERSIZE;
  }
  fc->extwrcounter=0;
  */
}


void* filerdthred(void * fil)
{
  struct FileChannel* fc = (struct FileChannel *) fil;
  int fd=(int) fc->fd;

  while(1){
    read(fd,fc->rdbuf,BUFFERSIZE);
  }
}

int looprd(struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  struct LoopChannel *lc=ch->data;
  int x,y,chnk=0;
  /* read in chunks into buf */

  lc->rdcounter=0;
  while (1){
    if (len-lc->rdcounter<CHUNK) chnk=len-lc->rdcounter;
    else chnk=CHUNK;

  x=read(lc->fd, &buf[lc->rdcounter],chnk);
  if (x<0) y=lseek(lc->fd,0,SEEK_SET);
  else {  
    /*g_log (0, G_LOG_LEVEL_DEBUG, "LOOP : x: %d y: %d",x,y);*/
    lc->rdcounter+=chnk;
    if (lc->rdcounter>=len) break;
  }
  /*  y=lseek(lc->fd,0,SEEK_SET);*/

  }

 
 


}

int
filerd (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  unsigned int x=0,cnt=0;
  struct FileChannel * fc = ch->data;

  read(fc->fd,buf,len);
  if (fc->extrdcounter+len>BUFFERSIZE) len=BUFFERSIZE-fc->extrdcounter;
  memcpy(&fc->rdbuf[fc->extrdcounter],buf,len);
  fc->extrdcounter+=len;
  if (fc->extrdcounter>=BUFFERSIZE) fc->extrdcounter=0;

  /*static pthread_t thread1_id;



  if (fc->first==0){

    fc->first=1;
    read(fc->fd,buf,len);

        pthread_create(&thread1_id, NULL, (void *)filerdthred, (void *)fc);
	return 0; 
 }
  */
  /* get chunk of rdbuffer.. inc extrdcounter */

  /*
    while (len>0){
      if (len>(BUFFERSIZE-fc->intrdcounter)) cnt=BUFFERSIZE-fc->intrdcounter;
      else cnt=len;
      for (x=0;x<cnt;x++){
	buf[x+fc->extrdcounter]=fc->rdbuf[fc->intrdcounter+x];
      }
      len=len-cnt;
      fc->intrdcounter+=cnt;
      fc->extrdcounter+=cnt;
      fc->intrdcounter=fc->intrdcounter%BUFFERSIZE;
    }
  fc->extrdcounter=0;
  */
}

int
filedstr (struct _Channel *ch)
{
  int fd = (int) ch->data;
  close (fd);
}

Channel * loopch (const char *looper)
{
  struct LoopChannel *lc;
  Channel *ch;
  int fd;
  ch = malloc (sizeof (Channel));
  lc=malloc (sizeof (struct LoopChannel));
  lc->rdcounter=1;
  ch->rd=looprd;
  ch->wr=0;
  ch->destroy=loopdstr;

  if ((fd = open (looper, O_RDONLY))<0) return 0;
  lc->fd=fd;


  ch->data=lc;
  return ch;
}



Channel * webch (void)
{
  struct WebChannel *wc;
  Channel *ch;
  ch = malloc (sizeof (Channel));
  wc=malloc (sizeof (struct WebChannel));
  wc->rdcounter=0;
  ch->rd=0;
  ch->wr=webwr;
  ch->destroy=webdstr;
  ch->data=wc;
  return ch;
}

int
webwr (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  /* open head ... write head to newfile ... close head write buf to newfile open tail write tail close tail */
  
  char block[1024];
  char *nl="\n";
  int in,out,x;
  int nread;
  struct WebChannel * wc = ch->data;

  /* filling buffer according to wrcounter */
  for (x=0;x<len;x++){
    wc->wrbuf[wc->rdcounter]=buf[x];
    wc->rdcounter++;
    wc->rdcounter=wc->rdcounter%(BUFFERSIZE/10);
  }

  in=open("/usr/local/httpd/htdocs/head", O_RDONLY);
  out=open("/usr/local/httpd/htdocs/new.html", O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR|S_IWUSR|S_IRGRP|S_IROTH);
  while((nread=read(in,block,sizeof(block)))>0) write(out,block,nread);
  close(in);

for (x=0;x<BUFFERSIZE/30;x+=60){
  write(out,&wc->wrbuf[x],60);
  write(out,nl,1);
}

  in=open("/usr/local/httpd/htdocs/tail", O_RDONLY);
  while((nread=read(in,block,sizeof(block)))>0) write(out,block,nread);
  close(in);
  close(out);

}

int
webdstr (struct _Channel *ch)
{
  struct WebChannel *wc = ch->data;
  free (wc);
}

int
shareddstr (struct _Channel *ch)
{
  struct SharedChannel *sc = ch->data;
 shmctl (sc->shmid3, IPC_RMID, 0);
 shmctl (sc->shmid4, IPC_RMID, 0);

  free (sc);

}

int
loopdstr (struct _Channel *ch)
{
  struct LoopChannel *wc = ch->data;
  free (wc);
}

Channel *
sharedch (void)
{

  struct SharedChannel *sharedc;
  Channel *ch;
  ch = malloc (sizeof (Channel));
  sharedc=malloc(sizeof(struct SharedChannel));
  /* set up shared memory */
  sharedc->shmid3=-1;
  sharedc->shmid4=-1;
  sharedc->shmid3=shmget (SHMKEY3, 1, IPC_CREAT | 0666);
  if (sharedc->shmid3 >= 0)
  shmctl (sharedc->shmid3, IPC_RMID, 0);

  if ((sharedc->shmid3 = shmget (SHMKEY3, SHRDSIZE2, IPC_CREAT | 0666)) < 0) {
    perror ("shmget(channel)");
    exit (1);
  }
  if ((sharedc->sharedbuffer1 = shmat (sharedc->shmid3, NULL, 0)) == 0) {
    perror ("shmat(channel)");
    exit (1);
  }
  sharedc->shmid4=shmget (SHMKEY4, 1, IPC_CREAT | 0666);
  if (sharedc->shmid4 >= 0)
  shmctl (sharedc->shmid4, IPC_RMID, 0);

  if ((sharedc->shmid4 = shmget (SHMKEY4, SHRDSIZE, IPC_CREAT | 0666)) < 0) {
    perror ("shmget(channel)");
    exit (1);
  }
  if ((sharedc->sharedbuffer2 = shmat (sharedc->shmid4, NULL, 0)) == 0) {
    perror ("shmat(channel)");
    exit (1);
  }


  sharedc->rdcounter=0;
  sharedc->wrcounter=0;
  ch->rd=sharedrd;
  ch->wr=sharedwr;
  ch->destroy=shareddstr;
  ch->data = (struct SharedChannel *) sharedc;
  return ch;
}

int
sharedwr (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  /*write to shared buffer  update wrcounter */
 
 unsigned int x=0,count=0,cnt=0;

  struct SharedChannel * sc = ch->data;
  /*  sc->wrcounter=0;*/

    while (len>0){
    if (len>(SHRDSIZE2-sc->wrcounter)) cnt=SHRDSIZE2-sc->wrcounter;
    else cnt=len;
    for (x=0;x<cnt;x++){
      sc->sharedbuffer1[sc->wrcounter+x]=buf[x+count];
    }
    len=len-cnt;
    sc->wrcounter+=cnt;
    count+=cnt;
    if (sc->wrcounter>=SHRDSIZE2) sc->wrcounter=0;
/*        sc->wrcounter=sc->wrcounter%SHRDSIZE2;*/
    }
   
}

int
sharedrd (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  struct SharedChannel *sc=ch->data;
  int x,y=0;
  /* read in chunks into buf */

  sc->rdcounter=0;
  for (x=0;x<len;x++){
    buf[x]=sc->sharedbuffer2[sc->rdcounter];
    if (sc->rdcounter>SHRDSIZE) sc->rdcounter=0;
  }


}

Channel *
filech (const char *fname, int flags)
{

  /*  pthread_t thread2_id;*/
  struct FileChannel *filec;
  Channel *ch;
  int fd, ioctl_frag,x,cnt,local;
  int speed=44100;
  local=0;

  if (strcmp(fname,"/dev/dsp")==0)
    Sound_Init();

  if ((fd = open (fname, flags))>=0){
    /* sound */
    if (strcmp(fname,"/dev/dsp")==0)
      {
	ioctl_frag=8;
	ioctl_frag +=10*65536;
	if (ioctl(fd, SNDCTL_DSP_SETFRAGMENT, &ioctl_frag) ==-1) {
	  perror("FRAG");
	  exit(1);

	}

	if (ioctl(fd, SNDCTL_DSP_SPEED, &speed) ==-1) {
	  perror("SETSPEED");
	  exit(1);
	  }
if (flags&O_RDWR)	  local=3;
 if (flags&O_RDONLY) local=1;
 if (flags&O_WRONLY) local=2;
      }
  }
  else {
    g_warning ("filech: Can't open file %s %u", fname, flags);
    return 0;
  }


  ch = malloc (sizeof (Channel));
  filec=malloc(sizeof(struct FileChannel));
  filec->fd=fd;
  filec->extrdcounter=0;
  filec->extwrcounter=0;
  filec->intrdcounter=0;
  filec->intwrcounter=0;

  /* init buffers */

  if (local>0) {
ch->mirrorname=1;
 ch->mirrorrw=local;
  }
  else {
    ch->mirrorname=0;
    ch->mirrorrw=0;
  }
  
  ch->data = (struct FileChannel *) filec;

  ch->rd=0;

  if (!(flags & O_WRONLY)){
    ch->rd = filerd;
    ch->wr=0; 

 filec->first=0;    
    
  }
    
  if ((flags & O_WRONLY) || (flags & O_RDWR)){
    ch->wr = filewr;
    /* start write thred */
    /*  pthread_create(&thread2_id, NULL, (void *)filewrthred, (void *)filec);*/
   

  }
  ch->destroy = filedstr;
  return ch;


}


typedef struct
{
  int counter;
  int fd;
}
MidiChannel;
 


void DrawLine(SDLchannel * sd, int x1,int y1,int x2,int y2);

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel);


int
videord (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  int chunk;
int counter=0;
  /* rather use threading */

  VideoChannel *vc = (VideoChannel *) ch->data;

       
  while (len>0){

    if (len>fg.image_size) chunk=fg.image_size;
    else chunk=len;
    if (vc->counter+chunk>fg.image_size) 
    {
    vc->counter=0;
    fg_get_next_image(&fg);
  }
  if (vc->counter3+chunk>=BUFFERSIZE) vc->counter3=0;
  memcpy (buf+counter, fg.current_image+vc->counter,chunk);
  
  memcpy(&vc->rdbuf[vc->counter3],fg.current_image+vc->counter,chunk);  
  vc->counter3+=chunk;
  
  vc->counter+=chunk; 
  len=len-chunk;
  counter+=chunk;
 }
}

int
videodstr (struct _Channel *ch)
{
  VideoChannel *vc = ch->data;
  /* is some other cleanup needed? */
fg_stop_grab_image(&fg);
 fg_close_device(&fg);
  free (vc);

}

int
sdldstr (struct _Channel *ch)
{
  SDLchannel *sd = ch->data;
  free (sd);
}


Channel *
videoch (const char *dev, int width, int height)
{
  int fd;
  VideoChannel *vc;
  Channel *ch;


  ch = malloc (sizeof (Channel));
  vc=malloc(sizeof(VideoChannel));


  if (fg_open_device (&fg, "/dev/video")==0)  
    {
      fg_set_channel (&fg, CHANNEL_COMPOSITE, VIDEOMODE_PAL);
      fg_start_grab_image(&fg, width, height, FORMAT_GREY);
      fg_get_next_image(&fg);
    vc->counter=0;
    vc->counter2=20;
    vc->counter3=0;
    ch->rd = &videord;
    ch->destroy = &videodstr;
    ch->data = vc;
    ch->mirrorname=2;
    ch->mirrorrw=1;

    return ch;

  } else {
    g_warning ("v2: Can't open video");
    return 0;
  }
}


int
sdlwr (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  SDL_Rect rect;
  Uint32 pix;
  int x=0,rest=0, fraglen=1024, counter=0;

  SDLchannel * sd = ch->data;
  int vwidth = sd->width/sd->blk, vheight=sd->height/sd->blk;


  if (SDL_MUSTLOCK (sd->screen)) {                                                  
    if (SDL_LockSurface (sd->screen) < 0) {                                         
      fprintf (stderr, "Can't lock screen: %s\n", SDL_GetError ());             
      return;                                                                   
    }                                                                           
  }  

  /* new*/
  if (sd->flag==1){
    rect.w=sd->width;
    rect.h=sd->height;;
    rect.x=0;
    rect.y=0;
    pix=SDL_MapRGB(sd->screen->format,0,0,0);
    SDL_FillRect (sd->screen, &rect, pix);


    for (x=0;x<len;x+=4){
      DrawLine(sd,(buf[x]*4)%sd->width,(buf[x+1]*4)%sd->height,(buf[x+2]*4)%sd->width,(buf[x+3]*4)%sd->height);
    }
 if (SDL_MUSTLOCK (sd->screen)) { 
     SDL_UnlockSurface (sd->screen);
       }
       
         SDL_UpdateRect (sd->screen, 0, 0,0,0);
         
  
  }
  else {
    rect.w=rect.h=sd->blk;
    for (x=0;x<len;x++){

      if (sd->counter>(vwidth*vheight)) 
	{
sd->counter=0;
  if (SDL_MUSTLOCK (sd->screen)) {                                                  
    SDL_UnlockSurface (sd->screen);                                                 
  }                                     

  SDL_UpdateRect (sd->screen, 0, 0,0,0);                                            


  if (SDL_MUSTLOCK (sd->screen)) {                                                  
    if (SDL_LockSurface (sd->screen) < 0) {                                         
      fprintf (stderr, "Can't lock screen: %s\n", SDL_GetError ());             
      return;                                                                   
    }                                                                           
  }  

	}
      pix=SDL_MapRGB(sd->screen->format,0,buf[x],0);
      rect.x=sd->blk*(sd->counter%(vwidth));
      rect.y=sd->blk*(sd->counter/(vwidth));
      SDL_FillRect (sd->screen, &rect, pix);
      sd->counter++;
    
    }
  }




}


Channel *
sdlch (int width, int height, int blk, int fl)
{
  /* init sdl */
  int bpp,i;     
 
  SDLchannel *sd;
  Channel *ch;
 
  ch = malloc (sizeof (Channel));
  sd = malloc (sizeof (SDLchannel));
      
  sd->flag=fl;
  /*
 if (SDL_Init (SDL_INIT_VIDEO) < 0) {
    fprintf (stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());         
    exit (1);                                                                    
 }
  SDL_ShowCursor (SDL_DISABLE);                                                 
                                                                                        
  atexit (SDL_Quit);           

  bpp =                                                                         
    SDL_VideoModeOK (width, height, 8, SDL_SWSURFACE | SDL_FULLSCREEN | SDL_HWPALETTE);
                                                                
  sd->screen =                                                                      
    SDL_SetVideoMode (width, height, bpp,SDL_SWSURFACE | SDL_FULLSCREEN | SDL_HWPALETTE);
          
                                                                      
 
  for (i=0;i<256;i++){                                                            
    sd->colors[i].r=0;                                                                  
    sd->colors[i].g=i;                                                                  
    sd->colors[i].b=0;                                                                  
  }                      
  */           
  sd->counter=0;
  sd->blk=blk;
  /* SDL_SetColors(sd->screen, sd->colors, 0, 256);           */
            
/* appropriate structures */

  sd->width=width;
  sd->height=height;

  ch->wr = &sdlwr;
  ch->rd=0;
  ch->mirrorname=2;
  ch->mirrorrw=2;
  ch->destroy = &sdldstr;
  ch->data = sd;
  return ch;
             


}



Channel *
midich (const char *dev)
{
  int fd;
  MidiChannel *mc;
  Channel *ch;

  if ((fd = open (dev, O_RDONLY)) >= 0) {
    ch = malloc (sizeof (Channel));
    mc = malloc (sizeof (MidiChannel));
    mc->fd = fd;
    
    mc->counter=0;
    ch->rd = &midird;
    ch->destroy = &mididstr;
    ch->data = mc;
    return ch;

  } else {
    g_warning ("m2: Can't open midi");
    return 0;
  }
}
   
int
mididstr (struct _Channel *ch)
{
  MidiChannel *mc = ch->data;
  close (mc->fd);
  free (mc);
}

int
midird (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  unsigned char inpacket[4];
  MidiChannel *mc = (MidiChannel *) ch->data;
  mc->counter=0;

  while (mc->counter<len){
    read(mc->fd,&inpacket, sizeof(inpacket));

    if (inpacket[0]==SEQ_MIDIPUTC && inpacket[1]<128){
      buf[mc->counter]=inpacket[1];
      mc->counter++;
    }
  } 

}

void DrawLine(SDLchannel * sd, int x1,int y1,int x2,int y2) 
{ 
  int dx,dy; 
  float m,b; 
  Uint32 pix;
 
  dx = x2 - x1; 
  dy = y2 - y1; 
  /*        if (dx==0 || dy==0 || x2<x1 || y2<y1) return;*/

  pix=SDL_MapRGB(sd->screen->format,0,255,0);
 
  putpixel(sd->screen,x1,y1,pix);
 
  /* Slope is less than 1, so draw adjacent to the y-axis. */ 
  if (abs(dx) > abs(dy)) { 
    m = (float)dy / (float)dx; 
    b = y1 - m * x1; 
 
    if (dx < 0) 
      dx = -1; 
    else 
      dx = 1; 
 
    while (x1 != x2) { 
      x1 += dx; 
      y1 = (int)ceil((float)(m * x1 + b)); 
      putpixel(sd->screen,x1,y1,pix);
                      
    } 
  } 
  /* Slope is greater than 1, so draw adjacent to the x-axis. */ 
  else if (dy != 0) { 
    m = (float)dx / (float)dy; 
    b = x1 - m * y1; 
 
    if (dy < 0) 
      dy = -1; 
    else 
      dy = 1; 
 
    while (y1 != y2) { 
      y1 += dy; 
      x1 = (int)ceil((float)(m * y1 + b)); 
      putpixel((SDL_Surface *)sd->screen,x1,y1,pix);
                     
    } 
  } 
}

void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
  int bpp = surface->format->BytesPerPixel;
  /* Here p is the address to the pixel we want to set */
  Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;
            
  switch(bpp) {
  case 1:
    *p = pixel;
    break;
                                    
  case 2:
    *(Uint16 *)p = pixel;
    break;
                     
  case 3:
    if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
      p[0] = (pixel >> 16) & 0xff;
      p[1] = (pixel >> 8) & 0xff;
      p[2] = pixel & 0xff;
    } else {
      p[0] = pixel & 0xff;
      p[1] = (pixel >> 8) & 0xff;
      p[2] = (pixel >> 16) & 0xff;
    }
    break;
  case 4:
    *(Uint32 *)p = pixel;
    break;
  }
}
