#ifndef _CHANNELS_H_
#define _CHANNELS_H_

#include "vm2.h"
#include "bgrab.h"
#include <dirent.h>
#include <stdlib.h>
#include <sys/stat.h>

#include "SDL.h"
#include "SDL/SDL_sound.h"
#include "SDL_image.h"

#define BUFFERSIZE 100000
#define BUFFERSIZ 102400

struct FileChannel
{
  int intrdcounter;
  int intwrcounter;
  int extrdcounter;
  int extwrcounter;
  unsigned char wrbuf[BUFFERSIZE];
  unsigned char rdbuf[BUFFERSIZE];
  int fd;
  int activ;
  int first;
};

typedef struct
{
  int width;
  int height;
  int counter;
  int blk;
  int flag; 
  SDL_Surface * screen;                                                            SDL_Event event;
  SDL_Color colors[256];  
}
SDLchannel;


typedef struct 
{
  int counter;
  int counter2;
  int counter3;
  unsigned char rdbuf[BUFFERSIZE];
  struct fgdevice * fg; 
}VideoChannel;


struct transsound{
  Uint32 audio_buffersize;
  Uint32 decode_buffersize;
  Uint8 *decoded_ptr;
  Uint32 decoded_bytes;
  Sound_Sample  * sample;

};


struct M_filesystem
{
  struct dirent *entry;
  struct stat statbuf;
  DIR *dp;
  int fd;
  struct transsound *data;
  char dir[1024];
  int flg, flg2, flg3;
  unsigned char  rdbuf[BUFFERSIZE];
  unsigned char wrbuf[BUFFERSIZE];
  unsigned char wrbuf2[BUFFERSIZE];
  int first;
  int endcount;
  int ending;
  int stop;
  int cap1;
  int cap2;
  int nature;
  int length;
  int length1;
  int length2;
};



Channel *filech (const char *fname, int flags);
Channel *videoch (const char *dev, int width, int height);
Channel *midich (const char *dev);
Channel *netch (void);
Channel *webch (void);
Channel *filesystemch (const char *filestart);
Channel *sdlch(int width, int height, int blk, int fl);
Channel *sniffch(void);
Channel *loopch(const char *looper);
Channel *sharedch(void);
Channel * bcastch(void);
#endif




