#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <dirent.h>
#include <sys/time.h>
#include <errno.h>
#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>

#include "channels.h"



#define GENSIZE 1024
#define PORT 9090
#define INITTL 10



typedef struct c_linked_list mlink;

mlink *tmphead;
mlink *tmpcurrent;


struct network
{
  int socket;
  struct sockaddr_in clntadr;	/* AF_INET */
  struct sockaddr_in newadr;
  struct sockaddr_in adr_srvr;
  int totalmapfile;
  char transbuffer[GENSIZE];
  int transptr;
  int size;
  int xx;
  char mp[GENSIZE*10];
  char dgram[GENSIZE];
  char ingram[GENSIZE*2];
  char tempbuf[GENSIZE];
  char mapfile[100];
  int pollcount;
  int counter;
};



/* Linked list structure */
struct c_linked_list
{
  char data[20];
  int ttl;
  struct c_linked_list *next;
};

/* Type definition for linked list structure */



void bail (const char *on_what);
void set_element (mlink * element, char *name);
void dump (mlink * element);
void add (struct network * net, char *name);
void delete (struct network *net);
mlink *create_element ();
void deallocate_list (mlink * element);
int sock_status (int sock, int to_secs, int to_msecs);
void find_element (struct network * net, char *which, int y);
void throwtog (char *which, struct network *net);
void savemapfile (mlink * map, struct network *net);
void poll (struct network *net);
void transmitcell (char *outbuf, int x, struct network *net, int len);
void openmapfile (struct network *net);
int is_there (char *which, struct network *net, int flag);
int inittran (struct network *net);
int netchdstr (struct _Channel *ch);
int netchwr (struct _Channel *ch, unsigned char *buf, unsigned int len);
int netchrd (struct _Channel *ch, unsigned char *buf, unsigned int len);

Channel *
netch (void)
{
  int x;
  struct network *net;
  Channel *ch;

  /* init net */
  ch = malloc (sizeof (Channel));
  net = malloc (sizeof (struct network));

  net->transptr = 0;
  net->xx = 2;
  net->totalmapfile=0;
  net->size = GENSIZE;
  net->pollcount = 0;

  memset (&net->newadr, 0, sizeof net->newadr);
  net->newadr.sin_family = AF_INET;
  net->newadr.sin_port = htons (PORT);

  strcpy (net->dgram, "request");

  /* set up socket */
  x = inittran (net);

  /* open mapfile */
  openmapfile (net);

  /*return ch */
  ch->rd = &netchrd;
  ch->wr = &netchwr;
  ch->destroy = &netchdstr;
  ch->data = net;
  return ch;

}

void
poll (struct network *net)
{
  static char tempchar[16];
  static char *tmpchar;
  static char ip[16];
  static char *mpp;
  int x, z, len_inet;

  len_inet = sizeof net->clntadr;

  mpp = net->mp;
  net->mp[0] = 0;
  /* throw tmpcurrent together as string */
  throwtog (mpp, net);

  /*printf("serversends: %s",mpp);*/
	   

  x = strlen (mpp);
  mpp[x] = 0;

  if (sock_status (net->socket, 0, 1)) {
    z = recvfrom (net->socket,
		  net->ingram,
		  sizeof net->ingram,
		  0, (struct sockaddr *) &net->clntadr, &len_inet);

    

    if (z > 0)
      net->ingram[z] = 0;

	    

    /* request */

    if (strcmp (net->ingram, "request") == 0 && z>0) {

      z = sendto (net->socket,	/* Socket to send result */
		  mpp,		/* The datagram result to snd */
		  strlen (mpp),	/* The datagram lngth */
		  0,		/* Flags: no options */
		  (struct sockaddr *) &net->clntadr,	/* addr */
		  len_inet);	/* Server address length */

      if (z < 0)
	bail ("srvrsend");


    }

    /* cell */

    else if (strncmp (net->ingram, "cell", 4) == 0 && z>0) {
      /* strip header off and place at channelpointer for netbuffer - may have wrap */
      for (x = 0; x < z - 4; x++) {
	net->transbuffer[(net->transptr + x) % net->size] = net->ingram[x + 4];

      }
      net->transbuffer[(net->transptr + x) % net->size] = 0;
      /* printf("cellrecv: %s",&net->transbuffer[net->transptr]);*/
      net->transptr += z - 4;
      /* printf("%d",net->transptr);*/

      if (net->transptr >= net->size) {
	net->transptr = 0;	/* wraps */
      }

	    

    }

    /* else process mapfile */

    /* if not from itself */

    /*	g_log(0,G_LOG_LEVEL_DEBUG,"IST: %s",net->ingram);*/

	  

    if (strncmp (net->ingram, "cell", 4) != 0
	&& strcmp (net->ingram, "request") != 0 &&strcmp( inet_ntoa (net->clntadr.sin_addr), inet_ntoa (net->adr_srvr.sin_addr))!=0 && z>0) {

      /* only deal with if is from last issued request -- decrease TTL -1 till 
	 zero if is not then discard */

      tmpchar = tempchar;



      for (x = 0; x < z; x++) {
	*tmpchar = net->ingram[x];

	if (*tmpchar == 'n') {
	  *tmpchar = 0;

	  if (is_there (tmpchar, net,1) == 0 && strlen(tmpchar)>1) {
	    add (net, tmpchar);
	    net->totalmapfile++;
	     
	    savemapfile (tmpcurrent, net);
	  }

	  tmpchar = tempchar;
	} else {
	  tmpchar++;

	}
      }

    }

	   
    /* see if new ip address */
    strcpy(tempchar,inet_ntoa (net->clntadr.sin_addr));
    /*  g_log(0,G_LOG_LEVEL_DEBUG,"IP:%s",tempchar);    */
       if (is_there (tempchar, net,0) == 0 && strlen(inet_ntoa (net->clntadr.sin_addr))>0 && strcmp(tempchar,"0.0.0.0")!=0) {
      add (net, inet_ntoa (net->clntadr.sin_addr));

      (int)net->totalmapfile++;
	    

      savemapfile (tmpcurrent, net);

      }
  }

  /* send request */

  /* not to send if still awaiting */
	    

  net->pollcount++;
  if (net->pollcount>100) {


    find_element (net, ip, net->xx);
    net->xx++;
    if (net->xx > net->totalmapfile)
      net->xx = 2;

    net->newadr.sin_addr.s_addr = inet_addr (ip);

    

    z = sendto (net->socket,	/* Socket to send result */
		net->dgram,	/* The datagram result to snd */
		strlen (net->dgram),	/* The datagram lngth */
		0,		/* Flags: no options */
		(struct sockaddr *) &net->newadr,	/* addr */
		len_inet);	/* Server address length */
    if (z < 0)
      bail ("clntsend");

    net->pollcount=0;
  }


    delete(net);
}


void
bail (const char *on_what)
{
  /*  fputs (strerror (errno), stderr);
      fputs (on_what, stderr);
      fputs (": ", stderr);
      fputc ('\n', stderr);*/
}

int
inittran (struct network *net)
{
  int z, len_inet;
  static const int True = 1;

  net->socket = socket (AF_INET, SOCK_DGRAM, 0);
  if (net->socket == -1)
    bail ("socket()");

  memset (&net->adr_srvr, 0, sizeof net->adr_srvr);
  net->adr_srvr.sin_family = AF_INET;
  net->adr_srvr.sin_port = htons (PORT);
  net->adr_srvr.sin_addr.s_addr = INADDR_ANY;

  len_inet = sizeof net->adr_srvr;

  z = bind (net->socket, (struct sockaddr *) &net->adr_srvr, len_inet);

  if (net->adr_srvr.sin_addr.s_addr == INADDR_NONE)
    bail ("bad address.");



  z = setsockopt (net->socket, SOL_SOCKET, SO_REUSEADDR, &True, sizeof True);
  if (z < 0)
    bail ("bind");
  return z;
}

int
sock_status (int sock, int to_secs, int to_msecs)
{
  struct timeval to;
  int sval;
  int ret_val = 1;
  fd_set check_set;

  FD_ZERO (&check_set);
  FD_SET (sock, &check_set);

  to.tv_sec = to_secs;

  to.tv_usec = to_msecs;
  if ((sval = select (sock + 1, &check_set, 0, 0, &to)) < 0)
    ret_val = -1;
  if (sval == 0)
    ret_val = 0;
  return (ret_val);
}

void
openmapfile (struct network *net)
{
  /* map straight into structures // or into mapfile string then into structures */

  int first, last;
  char mp[1000];
  char tmpchar[16];
  char *mpp;
  char *tempchar;
  char value[100] = "HOME";
  char *home;
  char *newfile = "/mapfile";
  int res;
  FILE *inmap;

  res = 0;
  mpp = mp;

  home = getenv (value);
  strcpy (net->mapfile, home);
  strcat (net->mapfile, newfile);

  inmap = fopen (net->mapfile, "r");
  net->totalmapfile = 0;
  first = 0;
  last = 0;
  tempchar = tmpchar;

  while (1) {
  
   
    while ((*mpp=fgetc(inmap)) != '\n' && *mpp != EOF) {
      *tempchar = *mpp;
      tempchar++;
      last = 0;
    } 
     
    
    *tempchar = 0;

    if (first == 0) {
      
      tmphead = create_element ();

      /* Enter the first ip address */
      
      strcpy (tmphead->data, tmpchar);
      tmphead->ttl=INITTL;
      
      tmphead->next = NULL;

      
      tmpcurrent = tmphead;
      first = 1;
net->totalmapfile++;
    } else {
      /* Add addresses to list */
if (strlen(tmpchar)>0) {     add (net, tmpchar);
      
net->totalmapfile++;
    }
    }




    tempchar=tmpchar; 
    
    if (*mpp == EOF)
      break;
  }




  fclose (inmap);

  /* Dump list to screen */
  /*      dump(current);
	  dump(tmpcurrent); */

  /* Kill list */
  /*      deallocate_list(current);
	  deallocate_list(tmpcurrent); */


}

mlink *
create_element ()
{
  return (mlink *) malloc (sizeof (mlink));
}

void
set_element (mlink * element, char *name)
{
  strcpy (element->data, name);
}

void
deallocate_list (mlink * element)
{
  mlink *current;

  /* Cycle through to the end of mlinked list */
  while (element != NULL) {
    /* Copy pointer */
    current = element;

    /* Get next pointer */
    element = (mlink *) element->next;

    /* Free old pointer */
    free (current);
  }
}

void
dump (mlink * element)
{
  /* Cycle through to the end of mlinked list */
  while (element->next != NULL) {
    printf ("%s\n", element->data);
    element = (mlink *) element->next;
  }

  /* Print final entry in list */
  printf ("%s\n", element->data);


}

void
add (struct network * net, char *name)
{
    

mlink*  element=(mlink *)tmpcurrent;

  /* Cycle through to the end of mlinked list */

if (strcmp(name,"127.0.0.1")==0) return;  

while (element->next != NULL) {
    element = (mlink *) element->next;
  }

  /* Create a new mlink */
  (mlink *) element->next = create_element ();
  element = (mlink *) element->next;

  /* Set values for element */
  element->next = NULL;		/* Empty pointer */
  strcpy (element->data, name);
  element->ttl=INITTL;
}

void
delete (struct network * net)
{

  int flag=0;
mlink*  element=(mlink *)tmphead;

  /* Cycle through to the end of mlinked list, searching
     for a string that matches name */
  while (element->next != NULL) {
if (net->totalmapfile>2)    element->next->ttl--;
    /* If the next element's TTL  */
    
    if (element->next->ttl<= 0 && net->totalmapfile>2) {

      mlink *temp_pointer;
      /* Get the element after next */
      temp_pointer = element->next->next;

      /* Free memory for the next pointer */
      free (element->next);

      /* Set the next element to the element after next */
      element->next = temp_pointer;
      flag=1;
	 
	    net->totalmapfile--;
	    
	 
	      	    break;

    }

    /* Continue checking next element */
    element = (mlink *) element->next;
  }
  if (flag==1)    { 
savemapfile (tmpcurrent, net);
	    if (net->xx > net->totalmapfile)
	      net->xx = 2;
  }
}


void
find_element (struct network * net, char *which, int y)
{
  int x;
mlink*  element=(mlink *)tmpcurrent;
 
/* g_log (0, G_LOG_LEVEL_DEBUG, "TOTAL: %d",net->totalmapfile);*/
 for (x = 0; x < y; x++) {
    if (x == (y - 1))
      strcpy (which, element->data);

    element = (mlink *) element->next;
  }

}

int
is_there (char *which, struct network *net, int flag)
{
  int x;
  int y = 0;

  

mlink*  element=(mlink *)tmpcurrent;
  
    for (x = 0; x < net->totalmapfile; x++)
/*  while (element->next != NULL)*/

 {
   
   


    if ((strcmp (element->data, which)) == 0) {
      y = 1;
      if (flag==0) element->ttl=INITTL;
      /*  g_log (0, G_LOG_LEVEL_DEBUG, "TTL: %s %d %d",which, element->ttl, net->totalmapfile);*/


      break;
    }



    element = (mlink *) element->next;

  }

    /*g_log (0, G_LOG_LEVEL_DEBUG, "xxxxx: %s %s %d %d",which,element->data,z,net->totalmapfile);*/

  return y;
}

void
throwtog (char *which, struct network *net)
{
  int x;
mlink*  element=(mlink *)tmpcurrent;

  for (x = 0; x < net->totalmapfile; x++) {
    sprintf (which, "%s%sn", which, element->data);
    element = (mlink *) element->next;
  }
}

void
savemapfile (mlink * map, struct network *net)
{
  int x;
  static char mp[GENSIZE];
  static char *mpp;
  FILE *outmap;

  outmap = fopen (net->mapfile, "w");

  mpp = mp;
  mp[0] = 0;
  /* throw tmpcurrent together as string */
  throwtog (mpp, net);
  x = strlen (mpp);
  mpp[x] = 0;

  for (x = 0; x < strlen (mp); x++) {
    if (mp[x] == 'n')
      fputc ('\n', outmap);
    else
      fputc (mp[x], outmap);
  }
  fclose (outmap);
}

void
transmitcell (char *outbuf, int place, struct network *net, int len)
{

  static char ip[16];
  int x, len_inet, z;

  strcpy (net->ingram, "cell");

  for (x = 0; x < len; x++) {
    net->ingram[4 + x] = outbuf[x];
  }
  net->ingram[4 + x] = 0;

  len_inet = sizeof net->newadr;

  place = (place % (net->totalmapfile-1)) + 2;

  /* g_log (0, G_LOG_LEVEL_DEBUG, "PLACE: %d",place);*/

  find_element (net, ip, place);


  net->newadr.sin_addr.s_addr = inet_addr (ip);

  z = sendto (net->socket,	/* Socket to send result */
	      net->ingram,	/* The datagram result to snd */
	      strlen (net->ingram),	/* The datagram lngth */
	      0,		/* Flags: no options */
	      (struct sockaddr *) &net->newadr,	/* addr */
	      len_inet);	/* Server address length */
  if (z < 0)
    bail ("cellsend");

  /*printf("cellsend to %s",ip);*/

}



int
netchdstr (struct _Channel *ch)
{

  struct network *net = ch->data;
  close (net->socket);
  free (net);
}

int
netchrd (struct _Channel *ch, unsigned char *buf, unsigned int len)
{

  struct network *net = (struct network *) (ch->data);
  int x;
  for (x = 0; x < len; x++) {
    buf[x] = net->transbuffer[net->counter];
    net->counter++;
    if (net->counter > GENSIZE) {
      poll (net);
      net->counter = 0;

    }
  }

}

int
netchwr (struct _Channel *ch, unsigned char *buf, unsigned int len)
{

  struct network *net = (struct network *) (ch->data);
  int count, lenny;
  int frag;
  /*break into chunks of GENSIZE*/
  count = 0;
  lenny = len;
  while (lenny > 0) {
    if (lenny < GENSIZE - 5)
      frag = lenny;
    else
      frag = GENSIZE - 5;
    transmitcell (&buf[count], rand () % 255, net, frag);
    lenny -= frag;
    count += frag;

  }

            poll (net);
}
