
#include <stdio.h>
#include <string.h>
#include <errno.h>  
#include <unistd.h>
#include <sys/socket.h>
/*#include <netdb.h>*/
#include <sys/types.h>  
#include <linux/in.h>
#include <linux/if_ether.h>
#include <net/if.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "channels.h"

#define BUFFERS 80000

static void bail(const char *on_what) {
  fputs(strerror(errno),stderr);
  fputs(on_what,stderr);
  fputc('\n',stderr);

  exit(1);
}


void* sniffrdthred(void *dat);

struct bcast{
  int sock;
  struct sockaddr_in adr_bc;
  int len_bc;
};

struct sniff{
  int sock;
  int intrdcounter;
  int extrdcounter;
  unsigned char rdbuf[BUFFERS];
};

int sniffrd (struct _Channel *ch, unsigned char *buf, unsigned int len);
int sniffdstr (struct _Channel *ch);

int bcastwr (struct _Channel *ch, unsigned char *buf, unsigned int len);
int bcastdstr (struct _Channel *ch);

Channel * bcastch(void){

  Channel *ch;
  struct bcast *bc;
  struct sockaddr_in adr_srvr;

  int res,sockfd,x,s,z;

  int len_srvr;
  static int so_reuseaddr = 1;
  int so_broadcast = 1;
  char *sv_addr = "192.168.22.107",  *bc_addr = "192.168.22.255:9096";
  

 ch=malloc(sizeof(Channel));
 bc=malloc(sizeof(struct bcast));


/* setup bcast socket */


 len_srvr = sizeof adr_srvr;
 bc->len_bc=sizeof bc->adr_bc;
 

z = mkaddr (
	     &adr_srvr,
	     &len_srvr,
	     sv_addr,
	     "udp");



 if (z == -1)
   bail("Bad server address");

 z = mkaddr (
	     &bc->adr_bc,
	     &bc->len_bc,
	     bc_addr,
	     "udp");      

 if (z == -1)
   bail("Bad bc address");

s = socket(AF_INET, SOCK_DGRAM,0);
if (s==-1) bail("socket()");


 z = setsockopt(s,
		SOL_SOCKET,
		SO_BROADCAST,
		&so_broadcast,
		sizeof so_broadcast);
                             
 if (z==-1)           
   bail("setsockopt(SO_BROADCAST)");

 z= bind(s,
	 (struct sockaddr *)&adr_srvr,
	 len_srvr);
 if (z==-1)
   bail("bind()");
 bc->sock=s;
 ch->rd=0;
 ch->wr=bcastwr;
 ch->data=(struct bcast *) bc;
 ch->destroy=bcastdstr;
 return ch;

}

int bcastwr (struct _Channel *ch, unsigned char *buf, unsigned int len){
  int x,y;
  struct bcast *bc=ch->data;
  for (y=0;y<len;y++){ 

 x=sendto(bc->sock,&buf[y],1,0,(struct sockaddr *)&bc->adr_bc,bc->len_bc);
  }
}


Channel * sniffch(void){
  int sock, n, x;
  unsigned char *iphead, *ethhead;
  struct ifreq ethreq;
  
  struct sniff *sn;
  Channel *ch;
  pthread_t thread1_id;
        
  ch = malloc (sizeof (Channel));
  sn = malloc (sizeof (struct sniff));    
  
  if ( (sock=socket(PF_PACKET, SOCK_RAW, 
                    htons(ETH_P_IP)))<0) {
    perror("socket");
    exit(1);
  }

  /* Set the network card in promiscuos mode */
  strncpy(ethreq.ifr_name,"eth0",IFNAMSIZ);
  if (ioctl(sock,SIOCGIFFLAGS,&ethreq)==-1) {
    perror("ioctl");
    close(sock);
    exit(1);
  }
  ethreq.ifr_flags|=IFF_PROMISC;
  if (ioctl(sock,SIOCSIFFLAGS,&ethreq)==-1) {
    perror("ioctl");
    close(sock);
    exit(1);
  }
  sn->sock=sock;
  ch->rd = &sniffrd;
  ch->wr = 0;
  ch->destroy = &sniffdstr;
  ch->data = sn;
  /* start thred */
  sn->extrdcounter=0;

  sn->intrdcounter=0;

  
  pthread_create(&thread1_id, NULL, (void *)sniffrdthred, (void *)sn);
  return ch;
}
  
  
int sniffrd (struct _Channel *ch, unsigned char *buf, unsigned int len)
{
  int x,cnt;
  struct sniff * sn = ch->data;


while (len>0){
if (len>(BUFFERS-sn->intrdcounter)) cnt=BUFFERS-sn->intrdcounter;
else cnt=len;
for (x=0;x<cnt;x++){
buf[x+sn->extrdcounter]=sn->rdbuf[sn->intrdcounter+x];
}
len=len-cnt;
sn->intrdcounter+=cnt;
sn->extrdcounter+=cnt;
sn->intrdcounter=sn->intrdcounter%BUFFERS;
}
sn->extrdcounter=0;

 
}


int sniffdstr (struct _Channel *ch)
{

  struct sniff *sn = ch->data;
  close (sn->sock);
  free (sn);
}  

int bcastdstr (struct _Channel *ch)
{
  struct bcast *bc=ch->data;
  close(bc->sock);
 free(bc);
}
      
void* sniffrdthred(void *dat)
{
  struct sniff* sn = (struct sniff *)dat;
  int sock=sn->sock;
  while(1)
    recvfrom(sock,sn->rdbuf,BUFFERS,0,NULL,NULL);

}







