#include <string.h>
#include <malloc.h>
#include <stdlib.h>

#include "vm2.h"
#include "channels.h"

#define ACTIV 10

int reparse (Machine *vm, unsigned int offset, unsigned int len, unsigned int sig, unsigned int flag);
int reparsebac (Machine *vm, unsigned int offset, unsigned int len, unsigned int sig, GList *laste);
int ldtfn (Machine * vm, Cell * cl, RawInstruction * ri);
int bitflip(unsigned char value);

int
nopfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*	cl->lively--;*/
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "nop");*/
  return;
}

int
btr0fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "bitshift right reg");*/
  /*  cl->regs.r[REGN (ri->arg.uc[0])] = cl->regs.r[REGN (ri->arg.uc[0])] >> 1;*/
  /*cl->regs.r[REGN (cl->regs.n.gp)]=cl->regs.r[REGN (cl->regs.n.gp)] >>1;*/
  cl->regs.r[0]=cl->regs.r[0] >>1;
  return;
}


int
btr1fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "bitshift right reg");*/
  /*  cl->regs.r[REGN (ri->arg.uc[0])] = cl->regs.r[REGN (ri->arg.uc[0])] >> 1;*/
  /*cl->regs.r[REGN (cl->regs.n.gp)]=cl->regs.r[REGN (cl->regs.n.gp)] >>1;*/
  cl->regs.r[1]=cl->regs.r[1] >>1;
  return;
}

int
btr2fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "bitshift right reg");*/
  /*  cl->regs.r[REGN (ri->arg.uc[0])] = cl->regs.r[REGN (ri->arg.uc[0])] >> 1;*/
  /*cl->regs.r[REGN (cl->regs.n.gp)]=cl->regs.r[REGN (cl->regs.n.gp)] >>1;*/
  cl->regs.r[2]=cl->regs.r[2] >>1;
  return;
}

int
btr3fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "bitshift right reg");*/
  /*  cl->regs.r[REGN (ri->arg.uc[0])] = cl->regs.r[REGN (ri->arg.uc[0])] >> 1;*/
  /*cl->regs.r[REGN (cl->regs.n.gp)]=cl->regs.r[REGN (cl->regs.n.gp)] >>1;*/
  cl->regs.r[3]=cl->regs.r[3] >>1;
  return;
}

int
btr4fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "bitshift right reg");*/
  /*  cl->regs.r[REGN (ri->arg.uc[0])] = cl->regs.r[REGN (ri->arg.uc[0])] >> 1;*/
  /*cl->regs.r[REGN (cl->regs.n.gp)]=cl->regs.r[REGN (cl->regs.n.gp)] >>1;*/
  cl->regs.r[4]=cl->regs.r[4] >>1;
  return;
}


int
btl0fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "bitshift left ");*/
  /*  cl->regs.r[REGN (ri->arg.uc[0])] = cl->regs.r[REGN (ri->arg.uc[0])] << 1;*/
  /*  cl->regs.r[REGN (cl->regs.n.gp)]=cl->regs.r[REGN (cl->regs.n.gp)] <<1;*/
  /* ??? */
  /*cl->regs.r[REGN (cl->regs.n.gp)]= cl->regs.r[REGN (cl->regs.n.gp)] % cl->len;*/
  /*  cl->regs.r[0]= cl->regs.r[0] % cl->len;*/
  cl->regs.r[0]= cl->regs.r[0]<<1;

  return;
}

int
btl1fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  cl->regs.r[1]= cl->regs.r[1]<<1;

  return;
}

int
btl2fn (Machine * vm, Cell * cl, RawInstruction * ri)
{

  cl->regs.r[2]= cl->regs.r[2]<<1;


  return;
}

int
btl3fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
 cl->regs.r[3]= cl->regs.r[3]<<1;
 return;
}

int
btl4fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
 cl->regs.r[4]= cl->regs.r[4]<<1;
 return;
}


int
in0fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "in0");*/
  cl->regs.r[0]++;
  return;
}

int
in1fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "in1");*/
  cl->regs.r[1]++;
  return;
}

int
in2fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "in2");*/
  cl->regs.r[2]++;
  return;
}

int
in3fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "in3");*/
  cl->regs.r[3]++;
  return;
}


int
in4fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "in4 %u",cl->regs.r[4]);*/
  cl->regs.r[4]++;
  return;
}

int
dec0fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "dec");*/
  if (REGN  (cl->regs.n.gp) !=0)
    /* cl->regs.r[REGN  (cl->regs.n.gp)]--;*/
    cl->regs.r[0]--;
  return;
}
int
dec1fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* g_log (0, G_LOG_LEVEL_DEBUG, "dec");*/
  if (REGN  (cl->regs.n.gp) !=0)
    /* cl->regs.r[REGN  (cl->regs.n.gp)]--;*/
    cl->regs.r[1]--;
  return;
}

int
dec2fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "dec");*/
  if (REGN  (cl->regs.n.gp) !=0)
    /* cl->regs.r[REGN  (cl->regs.n.gp)]--;*/
    cl->regs.r[2]--;
  return;
}

int
dec3fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* g_log (0, G_LOG_LEVEL_DEBUG, "dec");*/
  if (REGN  (cl->regs.n.gp) !=0)
    /* cl->regs.r[REGN  (cl->regs.n.gp)]--;*/
    cl->regs.r[3]--;
  return;
}

int
dec4fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "dec");*/
  if (REGN  (cl->regs.n.gp) !=0)
    /* cl->regs.r[REGN  (cl->regs.n.gp)]--;*/
    cl->regs.r[3]--;
  return;
}


/* q use of this */
/*int
  setfn (Machine * vm, Cell * cl, RawInstruction * ri)
  {
    g_log (0, G_LOG_LEVEL_DEBUG, "set");
  cl->regs.r[REGN (cl->regs.n.gp)] = ri->arg.uci.i;
  return;
  }*/

/*int
se0fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
g_log (0, G_LOG_LEVEL_DEBUG, "set");
  cl->regs.r[0] = ri->arg.uci.uc;
  return;
}*/

int
se1fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
 
  /* cl->regs.r[1] = ri->arg.uci.uc;*/

  cl->regs.r[1] = (*vm->mem+(cl->regs.n.mp%cl->len));

  /* g_log (0, G_LOG_LEVEL_DEBUG, "set1 %u", cl->regs.r[1]);*/

  return;
}

int
se2fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "set");*/
  /*  cl->regs.r[2] = ri->arg.uci.uc;*/
  cl->regs.r[2] = (*vm->mem+(cl->regs.n.mp%cl->len));


  return;
}

int
se3fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "set");*/
  /*  cl->regs.r[3] = ri->arg.uci.uc;*/

  cl->regs.r[3] = (*vm->mem+(cl->regs.n.mp%cl->len));


  return;
}

int
se4fn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "set");*/
  /*  cl->regs.r[4] = ri->arg.uci.uc;*/

  cl->regs.r[4] = (*vm->mem+(cl->regs.n.mp%cl->len));
  return;
}



int
putfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "put");*/
  /* address %len = cl->regs.r[REGN (ri->arg.uci.uc)]*/
  *(vm->mem + cl->offs + (cl->regs.n.mp %cl->len)) = cl->regs.n.gp;
}

int 
setfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* g_log (0, G_LOG_LEVEL_DEBUG, "setgp");*/
 cl->regs.n.gp= *(vm->mem + cl->offs + (cl->regs.n.mp %cl->len));
}

int
rllfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  unsigned int tmp, i;
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "rll 1 %u 2 %u 3 %u 4 %u 5 %u",cl->regs.r[0],cl->regs.r[1],cl->regs.r[2],cl->regs.r[3],cl->regs.r[4]);*/
  /*  cl->regs.r[REGN (ri->arg.uci.uc)] = ri->arg.uci.i;*/
  tmp = cl->regs.r[0];
  for (i = 0; i < REG_CNT - 1; i++){
    cl->regs.r[i] = cl->regs.r[i + 1];
    /* g_log (0, G_LOG_LEVEL_DEBUG, "rll %u",i);    */
  }
  cl->regs.r[i] = tmp;
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "rll 1 %u 2 %u 3 %u 4 %u 5 %u",cl->regs.r[0],cl->regs.r[1],cl->regs.r[2],cl->regs.r[3],cl->regs.r[4]);*/
    
     
  
  return;
}

int
sayfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  unsigned int chan, len;
  Channel *ch;
  unsigned char *b;

  if (vm->chcnt == 0)
    return;

  chan = (cl->regs.n.gp) % vm->chcnt;
  /*  len = ri->arg.uci.i % (vm->memsz + 1);*/
  /* len = cl->regs.n.mp % (cl->len+1);*/
  len = cl->regs.n.mp % (vm->memsz+1);

  if (len<1) return;

  /*  g_log (0, G_LOG_LEVEL_DEBUG, "say ch%u %u", chan, len);*/
  ch = g_list_nth_data (vm->channels, chan);
  if (ch->wr) {
    cl->lively+=2;
    b = malloc (len);
    cl2m (vm->mem, vm->memsz, cl->offs+cl->regs.n.rp, b, len);
    /*    cladv (0, vm->memsz, &(cl->regs.n.rp), len);*/
    ch->wr (ch, b, len);
    free (b);
  }
}


int mirfn (Machine *vm, Cell * cl, RawInstruction * ri)
{
  Channel *ch;
  unsigned int chan,len;
  unsigned char *c;
  struct FileChannel *fc;
  VideoChannel *vc;
  struct M_filesystem *mc;

  _mirror *mir =vm->mirror;

  len = cl->regs.n.mp % (vm->memsz+1);

  if (len<1) return;
  if (mir->snd==3){
 chan=mir->sndchan;
 ch = g_list_nth_data (vm->channels, chan);
 /*  g_log (0, G_LOG_LEVEL_DEBUG, "mirror ch%u", chan);*/
  fc =(struct FileChannel *) ch->data;
    /* deal with audio -- in this case use relevant channel function */
   


  /*  g_log (0, G_LOG_LEVEL_DEBUG, "mirror ch%u %u", chan, len);*/

  /* deal with mirpointer and wraparound */


  if (mir->soutcount+len>BUFFERSIZE) mir->soutcount=0;
  if (len>BUFFERSIZE) len=BUFFERSIZE;
    ch->wr (ch, &fc->rdbuf[mir->soutcount], len);
    mir->soutcount+=len;
    if (mir->soutcount>BUFFERSIZE) mir->soutcount=0;

  }

  /* deal with video mir */

  if (mir->vid==3){
 chan=mir->vidchan;
 ch = g_list_nth_data (vm->channels, chan);
 /*  g_log (0, G_LOG_LEVEL_DEBUG, "vmirror ch%u", chan);*/
  vc =(VideoChannel *) mir->data2;
    /* deal with video -- in this case use relevant channel function */
   


  /* deal with mirpointer and wraparound */

  if (mir->voutcount+len>BUFFERSIZE) mir->voutcount=0;
  if (len>BUFFERSIZE) len=BUFFERSIZE;
 ch->wr (ch, &vc->rdbuf[mir->voutcount], len);
    mir->voutcount+=len;
    if (mir->voutcount>BUFFERSIZE) mir->voutcount=0;
   
  }

  if (mir->filesnd==1){
    chan=mir->filechan;

 ch = g_list_nth_data (vm->channels, mir->sndchan);


    mc=(struct M_filesystem *) mir->data3;
    if (mc->length1>0){
   
      /* g_log (0, G_LOG_LEVEL_DEBUG, "fsmirror ch%u %d", chan, mc->endcount);*/
    if (mir->filesndcount+len>mc->length1) mir->filesndcount=0;
    if (len>BUFFERSIZE) len=BUFFERSIZE;
    
    ch->wr(ch,&mc->wrbuf[mir->filesndcount],len);
    mir->filesndcount+=len;
    if (mir->filesndcount>BUFFERSIZE) mir->filesndcount=0;
    }
  }

  if (mir->filevid==1){
    
chan=mir->filechan;
    ch=g_list_nth_data(vm->channels,mir->vidchan);
		    mc=(struct M_filesystem *)mir->data3;

		    if (mc->length2>0){

		      /*g_log (0, G_LOG_LEVEL_DEBUG, "fvmirror ch%u %d", chan, len);*/
    if (mir->filevidcount+len>mc->length2) mir->filevidcount=0;
    if (len>BUFFERSIZE) len=BUFFERSIZE;
    
        ch->wr(ch,&mc->wrbuf2[mir->filevidcount],len);
	/*  ch->wr(ch,mc->wrbuf2,mc->length2);*/
    mir->filevidcount+=len;
    if (mir->filevidcount>BUFFERSIZE) mir->filevidcount=0;
    }    
  }
}  

int
lsnfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  unsigned int chan, len,x;
  Channel *ch;
  unsigned char *b;
  int activ=0;
  if (vm->chcnt == 0)
    return;

  chan = cl->regs.n.gp % vm->chcnt;
  len = cl->regs.n.mp % (cl->len + 1);
  if (len<1) return;
  ch = g_list_nth_data (vm->channels, chan);
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "lsn ch%u %u", chan, len);*/
  if (ch->rd) {
    cl->lively+=2;
    b = malloc (len);
    x=ch->rd (ch, b, len);

    /* test activity */
    /* for (x=1;x<len/2;x++){
      if (b[x-1]==b[x]) activ++;
    }
    if (activ<len/ACTIV)*/
      m2cl (b, vm->mem + cl->offs, cl->len, cl->regs.n.wp, len);

    /*    cladv (cl->offs, cl->len, &(cl->regs.n.wp), len);*/
    free (b);
    
  }
}

int
splfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* split - split current cell into two */
  Cell *newcl;
  unsigned int noffs, nlen, npos;
  unsigned int shrink, xp;

  /*  g_log (0, G_LOG_LEVEL_DEBUG, "spl");*/

  xp = cl->regs.n.xp % cl->len;
  noffs = cl->offs + xp;
  nlen = cl->len - xp;
  
  if (nlen > sizeof (RawInstruction) && noffs > cl->offs) {
    /*  cl->lively += 4;*/
    newcl = malloc (sizeof (Cell));
    newcl->offs = noffs;
    newcl->len = nlen;
    memset (&newcl->regs, 0, sizeof (newcl->regs));
    npos = g_list_index (vm->cells, cl) + 1;
    vm->cells = g_list_insert (vm->cells, newcl, npos);
    newcl->lively = INITLIVELY;
    /*    g_log (0, G_LOG_LEVEL_DEBUG, "> new cell (%u,%u)", noffs, nlen);*/
  }
  
  shrink = cl->regs.n.xp > 0 ? cl->regs.n.xp - 1 : cl->len - 1;
  
  if (shrink < sizeof (RawInstruction)) {
    /* if the cell becomes shorter then longest possible instruction, it disappears */
    /*    g_log (0, G_LOG_LEVEL_DEBUG, "> del original cell");*/
    if (!(vm->cur_cell = g_list_next (vm->cur_cell))) {
      vm->cur_cell = g_list_first (vm->cells);
      return;
    }
    vm->cells = g_list_remove (vm->cells, cl);
    free (cl);
  } else {
    /* else - just shrink it */
    cl->len = shrink;
    /*    g_log (0, G_LOG_LEVEL_DEBUG, "> shrink original cell to %u", shrink);*/
  }
  
}

int mrgfn (Machine * vm, Cell * cl, RawInstruction * ri);
int mrbfn (Machine * vm, Cell * cl, RawInstruction * ri);
int cpofn (Machine * vm, Cell * cl, RawInstruction * ri);

int
cpyfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  unsigned char *buf;  
unsigned int len = cl->regs.n.mp % (cl->len + 1);
  if (len<1) return;

  (unsigned char *)buf = malloc (len);

  cl2m (vm->mem + cl->offs, cl->len, cl->regs.n.rp, buf, len);
  m2cl (buf, vm->mem + cl->offs, cl->len, cl->regs.n.wp, len);
  free (buf);
}



/* jump IF zero */
int
jizfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* unsigned int reg = REGN (cl->regs.n.gp);*/
  unsigned int addr = cl->regs.n.mp % cl->len;
  if (cl->regs.n.gp == 0)
    cl->regs.n.xp = addr;
}




InstructionDesc iset[] = {
  {1, nopfn}
  ,
  /*  {1, in0fn}
      ,*/
  /* {1, dec0fn}
     ,*/
  {1, dec1fn}
  ,
  {1, dec2fn}
  ,
  {1, dec3fn}
  ,
  {1, dec4fn}
  ,
  {1, mrgfn}
  ,
  {1, rllfn}
  ,
  /*  {2, se0fn}
      ,*/
  {1, splfn}			/* 6 */
  ,
  {1, se1fn}
  ,
  {1, se2fn}
  ,
  /*  {1, se3fn}
      ,*/
  {1,se4fn}
  ,
  {1, in1fn}
  ,
  {1, in2fn}
  ,
  {1, in3fn}
  ,
  {1, in4fn}
  ,
  {1, mrbfn}
  ,
    {1, sayfn}
      ,

  {1, lsnfn}
  ,
  {1, cpyfn}
  ,
  {1, jizfn}
  ,
  {1, ldtfn}
  ,
  /*  {1, btl0fn}
      ,*/
  /*  {1, btl1fn}
      ,*/
  /* {1, btl2fn}
     ,*/
  {1, btl3fn}
  ,
  {1, btl4fn}
  ,
  /* {1, btr0fn}
     ,
  {1, btr1fn}
  ,      
  {1, btr2fn}
  ,   */   
  {1, btr3fn}
   ,      
  {1, btr4fn},

  {1,mirfn}  
  ,      
  {1, putfn}
  ,
  {1, cpofn}
  ,
  {1,setfn}
  ,
  {1,nopfn},
  {1,nopfn},
  {1,nopfn}
};

int isetsz = sizeof (iset) / sizeof (InstructionDesc);

/* jump to template function - mar - now sets register to address of match */
int
ldtfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  unsigned int ipp = cl->regs.n.xp;
  unsigned int start = cl->offs + ((cl->regs.n.xp + 2) % cl->len);

  /* serch from ipp to end cell and back agenn to find matching arg.uci.i */
  /* if found then change regs.n.xp to this */

  while (1) {
    if (((*vm->mem + start)&(isetsz-1)) == 21 ) {
      /*	cl->regs.n.xp = start;*/
      cl->regs.n.mp = (start - cl->offs);

      /*      g_log (0, G_LOG_LEVEL_DEBUG, "ldtfn: reg mp set to %d", start- cl->offs);*/
      return;
    }

    start++;
    if (start > cl->offs + cl->len)
      start = cl->offs;

    if (start == cl->offs + (cl->regs.n.xp % cl->len) - 2)
      return;

    if (start - (cl->offs + ((cl->regs.n.xp + 2) % cl->len)) > cl->len)
      return;

  }
}



int
mrgfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* merges with what follows - either next cell or garbage */
  unsigned int mrgstart, mrgend, i;
  GList *next;
  Cell *nextcell;

  /*  g_log (0, G_LOG_LEVEL_DEBUG, "mrg");*/
  mrgstart = cl->offs + cl->len;
  if (mrgstart == vm->memsz) {
    /* last cell not followed by anything */
    return;
  }
  if (!(next = g_list_next (vm->cur_cell))) {
    mrgend = vm->memsz - 1;
    
  }  else {
    g_assert (nextcell = (Cell *) next->data);
    if (mrgstart + 1 >= nextcell->offs) {


      mrgend = nextcell->offs + nextcell->len - 1;
      vm->cells = g_list_remove (vm->cells, nextcell);
      free (nextcell);
      
    } 
    
    else {

      mrgend = nextcell->offs - 1;
    }
  }

  //  for (i = mrgstart; i <= mrgend; i++) {
  //    if (vm->mem[i] % isetsz == 6 /* cop of spl */ ) {
  //      vm->mem[i] = 0;		/* cop of nop */
  //      break;
  //    }
  //  }

  /* ??? */
  cl->len = mrgend + 1  - cl->offs;
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "mrgerr len: %u offs %u end %u",cl->len, cl->offs, mrgend);*/

}

int mrbfn (Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* merges with what preceeds - either next cell or garbage */
  unsigned int mrgstart, mrgend, i;
  GList *prev;
  Cell *prevcell;

  /*  g_log (0, G_LOG_LEVEL_DEBUG, "mrb");*/

  mrgend = cl->offs;
  if (mrgend == 0) {
    /* nothing to merge with */
    return;
  }
  if (!(prev = g_list_previous (vm->cur_cell))) {
    /* follows only garbage */
    mrgstart = 0;
  } else {
    g_assert (prevcell = (Cell *) prev->data);
    if (mrgend == prevcell->offs + prevcell->len) {
      /* follows other cell - merging two together */
      mrgstart = prevcell->offs;
      /* the prevcell must be erased */
      vm->cells = g_list_remove (vm->cells, prevcell);
      free (prevcell);
    } else {
      /* follows by some garbage (preceeded by other cell(s) */
      mrgstart = prevcell->offs + prevcell->len;
    }
  }
  //  for (i = mrgstart; i <= mrgend; i++) {
  //    if (vm->mem[i] % isetsz == 6 /* cop of spl */ ) {
  //      vm->mem[i] = 0;		/* cop of nop */
  //      /*break; */
  //    }
  //  }


  cl->regs.n.xp = (cl->regs.n.xp % cl->len) + mrgend - mrgstart;
  cl->offs = mrgstart;
  cl->len += mrgend - mrgstart;
}

int
m2cl (unsigned char *buf, unsigned char *cbuf, unsigned int clen,
      unsigned int offs, unsigned int len)
{
  unsigned int lenstart, leftover;

  len = len % (clen + 1);
  offs = offs % clen;
  /* g_log (0, G_LOG_LEVEL_DEBUG, "m2cl(clen=%u,offs=%u,len=%u)", clen, offs, len);*/
  if (offs + len < clen)
    leftover = 0;
  else
    leftover = offs + len - clen;
  lenstart = len - leftover;

  memcpy (cbuf + offs, buf, lenstart);
  if (leftover)
    memcpy (cbuf, buf + lenstart, leftover);

  return 0;
}

int
cl2m (unsigned char *cbuf, unsigned int clen, unsigned int offs,
      unsigned char *buf, unsigned int len)
{
  unsigned int lenstart, leftover;

  len %= (clen + 1);
  offs %= clen;
  /*  g_log (0, G_LOG_LEVEL_DEBUG, "cl2m(clen=%u,offs=%u,len=%u)", clen, offs, len);*/
  if (offs + len < clen)
    leftover = 0;
  else
    leftover = offs + len - clen;
  lenstart = len - leftover;

  memcpy (buf, cbuf + offs, lenstart);
  if (leftover)
    memcpy (buf + lenstart, cbuf, leftover);

  return 0;
}

int
cpofn(Machine * vm, Cell * cl, RawInstruction * ri)
{
  /* start point would be end of cell + rp .. copy into wp address. take care of wraps for both memsz & copy in (jus use m2cl) */
  unsigned int lenstart, leftover,clen;
 
  unsigned int offs = cl->offs + cl->len;
 
  unsigned int len = cl->regs.n.mp % (cl->len + 1);
  unsigned char *buf = malloc (len);
    
  /* free memcpy*/
    
  clen=vm->memsz; /* ? */
  if (clen-offs>0){

    len%=(clen-offs);

    /*cl->lively++;*/

    /*    g_log (0, G_LOG_LEVEL_DEBUG, "cpofn(clen=%u,offs=%u,len=%u)", clen, offs, len);*/
    if (offs + len < clen)
      leftover = 0;
    else
      leftover = offs + len - clen;
    lenstart = len - leftover;

    memcpy (buf, vm->mem + offs, lenstart);
    if (leftover)
      memcpy (buf + lenstart, vm->mem + offs, leftover);
    
    m2cl (buf, vm->mem + cl->offs, cl->len, cl->regs.n.wp, len);
    free (buf);
  }
  return 0;

}

int
initMachine (Machine * vm)
{
  vm->mem = 0;
  vm->memsz = 0;
  vm->cells = 0;
  vm->cur_cell = 0;
  vm->channels = 0;
  vm->chcnt = 0;
}

/* assumes memory is already allocated */
int
resetMachine (Machine * vm)
{
  void freedata (gpointer data, gpointer userdata)
    {
      free (data);
    }
  /*  Cell *prim_cell;*/

  Cell *newcl;
  unsigned int noffs, nlen, npos;
  unsigned int shrink, xp;


  /* ensure we wont die of segfault */
  g_assert (vm);
  g_assert (vm->mem);
  g_assert (vm->memsz);

  /* delete all cells */
  if (vm->cells) {
    g_list_foreach (vm->cells, freedata, 0);
    g_list_free (vm->cells);
    vm->cells = 0;
  }

  /* create one primordial cell */
  /*  prim_cell = malloc (sizeof (Cell));
      prim_cell->offs = 0;
      prim_cell->len = vm->memsz;
      memset (&prim_cell->regs, 0, sizeof (prim_cell->regs));
      vm->cells = g_list_append (vm->cells, prim_cell);
      vm->cur_cell = g_list_first (vm->cells);
      prim_cell->lively = INITLIVELY;*/
  
  /* parse cellspace for 42 boundary -- allocate cells then reset cur-cell */

  reparse(vm,0,vm->memsz,6,1); 
  
  vm->cur_cell = g_list_first (vm->cells);
  
  
}

int
ricop (RawInstruction * ri)
{

    return ri->cop&(isetsz-1);
  /*return ri->cop%isetsz;*/
  /*if (ri->cop>=isetsz) ri->cop=0;
    return ri->cop;*/



}

/* execute current instruction of the current cell */
int
step (Machine * vm)
{
  void freedata (gpointer data, gpointer userdata)
    {
      free (data);
    }

  Cell *cur_cell, *prev_cell = 0;
  RawInstruction rawinst;
  InstructionDesc *inst;
  int indxx;

  /* assertions - exit if not true */
  g_assert (vm);
  g_assert (vm->cur_cell);
  g_assert (vm->cur_cell->data);

  /* get current cell */
  cur_cell = (Cell *) vm->cur_cell->data;
  /*  g_log (0, G_LOG_LEVEL_DEBUG,
	 "step cur_cell #%d, offs=%u, len=%u, xp=%u lively=%d",
	 g_list_index (vm->cells, cur_cell), cur_cell->offs, cur_cell->len,
	 cur_cell->regs.n.xp, cur_cell->lively);*/

  /* is it lively? */

  cur_cell->lively--;
  if (cur_cell->lively <= 0) {
    /* KILL (long as we have one cell)*/
    if (g_list_length (vm->cells) > 1) {

      /*      g_log (0, G_LOG_LEVEL_DEBUG, "########KILL # %d no of cells: %d",
	      g_list_index (vm->cells, cur_cell), g_list_length (vm->cells));*/

      indxx= g_list_index (vm->cells, cur_cell);

      vm->cells = g_list_remove (vm->cells, cur_cell);
      free (cur_cell);

      /*      vm->cur_cell = g_list_first (vm->cells);*/
      if (indxx==g_list_length(vm->cells))  vm->cur_cell = g_list_first (vm->cells);
      else vm->cur_cell=g_list_nth(vm->cells,indxx);

      return;
    } else {
      /* reboot copy prog to cell and make current cell ?? */
      /*      g_log (0, G_LOG_LEVEL_DEBUG, "########REBOOTED########");*/

      vm->cells = g_list_remove (vm->cells, cur_cell);
      free (cur_cell);

      /* re-parse cell space */

      resetMachine(vm);
      return;
      /*

	reparse(vm,0,vm->memsz,rand()%255);
      */


      /*
      g_log(0,G_LOG_LEVEL_DEBUG,"got here...len %d %d %d",cur_cell->len,g_list_index (vm->cells, cur_cell), g_list_length (vm->cells));
      */

      /*      cur_cell->lively = INITLIVELY;
	      cur_cell->regs.n.xp = 0;
	      *(vm->mem + cur_cell->offs) = 8;
	      *(vm->mem + cur_cell->offs + 1) = 0;
	      *(vm->mem + cur_cell->offs + 2) = 254;
	      cur_cell->lively = INITLIVELY;*/

    }
  }

  /* fetch instruction */
  //g_log(0,G_LOG_LEVEL_DEBUG,"fetch...");
  cl2m (vm->mem + cur_cell->offs, cur_cell->len, cur_cell->regs.n.xp,
	(unsigned char *) &rawinst, sizeof (rawinst));
  //g_log(0,G_LOG_LEVEL_DEBUG,"...done");
  /* execute instruction */
  /* advance execution pointer */
  inst = iset + ricop (&rawinst);
  cladv (cur_cell->offs, cur_cell->len, &(cur_cell->regs.n.xp), inst->adv);
  inst->fn (vm, cur_cell, &rawinst);
}

/* advances a pointer inside a circular buffer */
int
cladv (unsigned int offs, unsigned int clen, unsigned int *p, unsigned int adv)
{
  //g_log(0,G_LOG_LEVEL_DEBUG,"cladv(offs=%u,clen=%u,p=%u,adv=%u)",offs,clen,*p,adv);
  *p %= clen;
  *p += adv;
  if (*p > offs + clen) {
    unsigned int diff = *p - (offs + clen);
    *p = offs + diff % clen;
  }
  //g_log(0,G_LOG_LEVEL_DEBUG,"> new pointer: %u",*p);
  return *p;
}

int mutate(Machine *vm)
{
  int x=rand()%vm->memsz;

  (unsigned char)vm->mem[x]=bitflip(vm->mem[x]);
}

int
gcollect (Machine * vm)
{
  unsigned int garbage = 0, garblen = 0, first = 0;
  GList *iter;

  for (iter = g_list_first (vm->cells); iter != NULL; iter = g_list_next (iter)) {
	
    Cell *cl = (Cell *) iter->data;
    first=0;
    if ((garblen = (cl->offs - garbage)) > sizeof (RawInstruction) && garbage<cl->offs) {


      /*      g_log(0,G_LOG_LEVEL_DEBUG,">garbage coll offs %u len%u",cl->offs, garblen);*/
      if (garblen<vm->memsz && garblen>0)
	reparsebac(vm,garbage,garblen,6,iter);

      /*      Cell *newcl = malloc (sizeof (Cell));
	      newcl->offs = garbage;
	      newcl->len = garblen;
	      memset (&newcl->regs, 0, sizeof (RegSet));
	      newcl->lively = INITLIVELY;
	      g_list_prepend (iter, newcl);	
	      vm->cells = g_list_first(vm->cells);*/

      /*      g_log(0,G_LOG_LEVEL_DEBUG,">garbage coll");*/
    }
    
    garbage = cl->offs + cl->len;
    first++;
  }

  if ((garblen = (vm->memsz - garbage)) > sizeof (RawInstruction)) {

    reparse(vm,garbage,garblen,6,0);


    /*   Cell *newcl = malloc (sizeof (Cell));
	 newcl->offs = garbage;
	 newcl->len = garblen;
	 memset (&newcl->regs, 0, sizeof (RegSet));
	 newcl->lively = INITLIVELY;
	 vm->cells = g_list_append (vm->cells, newcl);*/
    /*    g_log(0,G_LOG_LEVEL_DEBUG,">garbage coll");*/
  }

  
}

int
reparse (Machine *vm, unsigned int offset, unsigned int len, unsigned int sig, unsigned int flag){
  Cell *newcl;

  unsigned int x=0,last=0,nlen=0,count=0;

  for (x=0;x<len;x++){

    if (((unsigned char)vm->mem[offset+x]&31)==sig) { 

      nlen=x-last;  

      if (nlen > sizeof (RawInstruction) && nlen<vm->memsz) {              
	newcl = malloc (sizeof (Cell));
	newcl->offs = last+offset+1;
	newcl->len = nlen-1;
	memset (&newcl->regs, 0, sizeof (RegSet));
	newcl->lively = INITLIVELY;
	vm->cells=g_list_append (vm->cells, newcl);	

	/*g_log(0,G_LOG_LEVEL_DEBUG,"len: %d >repars",newcl->len);*/
      
	last=x;
	count++;
      }
      /* else              
	      g_log(0,G_LOG_LEVEL_DEBUG,">repars--short");*/

    }}

  if (count==0 && flag==1) reparse(vm,offset,len,rand()%(sig+1),1);
  else return;


}


int
reparsebac (Machine *vm, unsigned int offset, unsigned int len, unsigned int sig, GList *laste){
  Cell *newcl;

  int indx;
  unsigned int x=0,last=0,nlen=0,count=0;

  last=len;
  /* ??? */

  for (x=len;x>0;x--){

    if (((unsigned char)vm->mem[offset+x]&31)==sig) { 

      nlen=last-x-1;  

      if (nlen > 6  && nlen<vm->memsz) {              
	newcl = malloc (sizeof (Cell));
	newcl->offs = x+offset+1;
	newcl->len = nlen;
	memset (&newcl->regs, 0, sizeof (RegSet));
	newcl->lively = INITLIVELY;

	indx=g_list_position(vm->cells,laste);
	if (indx<=0) indx=0;

	vm->cells=g_list_insert(vm->cells, newcl,indx);


	/*	g_log(0,G_LOG_LEVEL_DEBUG,"len: %d >reparsbac",newcl->len);*/
	/*     vm->cells = g_list_first(vm->cells);*/
	laste = g_list_nth(vm->cells, indx);
	last=x;
	count++;
      }
      /* else
	              g_log(0,G_LOG_LEVEL_DEBUG,">reparsbac--short");*/

    }}


}

 
int bitflip(unsigned char value){
  unsigned char i,j,k;
  k=1;  
i=rand()%6;
  for (j=0;j<i;j++){
    k=k*2;
  }
  value=value^k;
  return value;
}

