#ifndef _VM2_H_
#define _VM2_H_

#include <glib.h>

typedef union
{
  struct RegByName
  {
    unsigned int xp;
    unsigned int wp;
    unsigned int rp;
    unsigned int gp;
    unsigned int mp;
  }
  n;
  unsigned int r[sizeof (struct RegByName) / sizeof (int)];
}
RegSet;
#define REG_CNT (sizeof(struct RegByName)/sizeof(int))
#define REGN(a) a%REG_CNT

typedef struct
{
  unsigned int offs;
  unsigned int len;
  signed int lively;
  RegSet regs;
}
Cell;

#define INITLIVELY 100

typedef struct
{
  void *data1;
  void *data2;
  void *data3;

  unsigned int vid;
  unsigned int vidchan;
  unsigned int voutcount;
  unsigned int snd;
  unsigned int soutcount;
  unsigned int sndchan;
  unsigned int filechan;
  unsigned int filesnd;
  unsigned int filevid;
  unsigned int filesndcount;
  unsigned int filevidcount;
}
_mirror;

struct _Channel;
typedef int ChannelFn (struct _Channel *ch, unsigned char *buf,
		       int unsigned len);
typedef int ChDestroyFn (struct _Channel *ch);

typedef struct _Channel
{
  void *data;
  ChannelFn *rd;
  ChannelFn *wr;
  ChDestroyFn *destroy;
  int mirrorname;
  int mirrorrw;
}
Channel;

typedef struct
{
  unsigned char *mem;
  unsigned int memsz;

  GList *cells;
  GList *cur_cell;
  GList *channels;
  unsigned int chcnt;
  _mirror *mirror;
  int capable[10];
}
Machine;

struct _RawInstruction
{
  unsigned char cop;
  union
  {
    unsigned int i;
    struct
    {
      unsigned char uc;
      unsigned int i;
    }
    __attribute__ ((packed)) uci;
    unsigned char uc[4];
  }
  __attribute__ ((packed)) arg;
}
__attribute__ ((packed));
typedef struct _RawInstruction RawInstruction;

typedef int InstructionFn (Machine * vm, Cell * cl, RawInstruction * ri);

typedef struct
{
  unsigned int adv;		/* what to add to xp */
  InstructionFn *fn;
}
InstructionDesc;

int gcollect(Machine *vm);

/* 
 * cell <--> normal memory copy
 */

int cl2m (unsigned char *cbuf, unsigned int clen, unsigned int offs,
	  unsigned char *buf, unsigned int len);
int m2cl (unsigned char *buf, unsigned char *cbuf, unsigned int clen,
	  unsigned int offs, unsigned int len);
int cladv (unsigned int offs, unsigned int clen, unsigned int *pointer,
	   unsigned int adv);

#endif
